#include "dynamicentity.h"
#include "../drawable/maze.h"

std::unique_ptr<IDynamicEntity> Enemy::clone() const {
	return std::make_unique<Enemy>(*this);
}

void Enemy::action() {
	auto miliseconds = static_cast<size_t>(m_stopwatch.getElapsedTime().asMilliseconds());
	if (miliseconds < rand() % 10000)
		return;
	auto direction = static_cast<Room::Direction>(rand() % 4);
	m_ptr_room->get_side(direction)->enter(this);
	m_stopwatch.restart();
}

void Enemy::prepare_for_drawing()
{
	m_rectangle.setPosition(m_ptr_room->get_position());
}

void Enemy::draw_into(sf::RenderWindow& window) const
{
	window.draw(m_rectangle);
}



