#pragma once 
#include "ientity.h"


class IDynamicEntity : public IEntity, public IVisitable {
public:
	virtual std::unique_ptr<IDynamicEntity> clone() const = 0;
	void virtual action() = 0;
	virtual ~IDynamicEntity() = 0 {}
};

class Enemy : public IDynamicEntity {
	Enemy();
	void action() override;
	void prepare_for_drawing() override;
	void draw_into(sf::RenderWindow& window) const override;
	virtual std::unique_ptr<IDynamicEntity> clone() const override {return std::make_unique<Enemy>(*this); }
	private:
	sf::RectangleShape m_rectangle;
	sf::Clock m_stopwatch;
};

