#pragma once 
#include "ientity.h"
#include <memory>
#include "../drawable/maze.h"

class IVisitor {
public:
	virtual std::unique_ptr<IGameEvent> visit(Food* ptr_food) = 0;
	virtual std::unique_ptr<IGameEvent> visit(Enemy* ptr_enemy) = 0;

};

class Pacman : public IEntity, public IVisitor {
	Pacman() {}
	virtual void prepare_for_drawing() override {}
	virtual void draw_into(sf::RenderWindow& window) const override {}
	void move(Room::Direction direction);
	virtual  std::unique_ptr<IGameEvent> visit(Food* ptr_food) override {}
	virtual  std::unique_ptr<IGameEvent> visit(Enemy* ptr_enemy) override {}
};